Attribute VB_Name = "MTimer"
Option Explicit

Private Declare Function KillTimer Lib "user32" (ByVal hwnd As Long, ByVal nIDEvent As Long) As Long
'GREGBTIMERCHANGE
' API declaration used for "soft referencing" in GetCTimer and GetCTimers.
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (pDest As Any, pSrc As Any, ByVal ByteLen As Long)

'each timer class registers a pointer to its instance in this collection
'key= "id:" & timerID , item = reference to live class object
Public timers As New Collection

'each CTimers class registers a pointer to its instance by its class key here
'key= "key:" & intID , item = reference to live class object
Public CTimersCol As New Collection

Private mTimersColCount As Integer

Sub TimerProc(ByVal hwnd As Long, ByVal uMsg As Long, _
              ByVal idEvent As Long, ByVal dwTime As Long)
    
    Dim t As CTimer
    Dim c As CTimers
    
    On Error Resume Next
'GREGBTIMERCHANGE
'    Set t = timers("id:" & idEvent)
    ' Call GetCTimer to get the actual reference to the CTimer instead of the pointer stored in timers.
    Set t = GetCTimer("id:" & idEvent)
    If t Is Nothing Then
        KillTimer 0&, idEvent
    Else
        If t.ParentsColKey > 0 Then  'this timer is an index in CTimers
'GREGBTIMERCHANGE
'            Set c = CTimersCol("key:" & t.ParentsColKey)
            ' Call GetCTimers to get the actual reference to the CTimers object instead of the pointer stored in CTimersCol.
            Set c = GetCTimers("key:" & t.ParentsColKey)
            If c Is Nothing Then
                 KillTimer 0&, idEvent
                 Debug.Print "THIS SHOULDNT HAPPEN: parent collection died?"
            Else
                'raise the event in the parent collection class instead of timer class
                c.RaiseTimer_Event t.Index
            End If
        Else
            t.RaiseTimer_Event
        End If
    End If
    Set t = Nothing
'GREGBTIMERCHANGE
    Set c = Nothing
    
End Sub

'returns key to this class in collection
Function RegisterTimerCollection(c As CTimers) As Integer
    Dim key As String

    mTimersColCount = mTimersColCount + 1
    key = "key:" & mTimersColCount 'will always be unique because counting
'GREGBTIMERCHANGE
'    CTimersCol.Add c, key
    ' Use "soft referencing" to avoid a circular reference with the CTimersCol collection.
    '   Store the pointer to this class instead of a reference to this class.
    CTimersCol.Add ObjPtr(c), key
    RegisterTimerCollection = mTimersColCount
    
End Function


'GREGBTIMERCHANGE
Function GetCTimer(id As String) As CTimer
' This function returns an actual reference to the CTimer object "soft referenced" in the timers collection.
' It uses the CopyMemory API function to create the actual reference from the pointer value.
' The CTimer class uses "soft referencing" in order to avoid a circular reference with the timers collection.
' The timers collection stores pointers to the CTimer object memory locations instead of direct references to the objects.
' If we do not use soft referencing then when the calling code does this
'      Set timerMyTimer = Nothing
'   the timerMyTimer instance would still stay in memory because the timers collection (in MTimer)
'   is still holding a reference to it and the timerMyTimer.Class_Terminate event never fires.
    
    ' Temporal object.
    Dim timerTemp As CTimer
    ' Private variable to hold the pointer to the CTimer.
    Dim lngPtr As Long
    
On Error Resume Next
    ' Get the pointer that is stored in the timers collection.
    lngPtr = timers(id)
    If Err <> 0 Then
        ' The timer doesn't exist.
        Set GetCTimer = Nothing
    Else
On Error GoTo 0
        ' Copy the pointer stored in lngPtr to the temporal object variable.
        ' A Long is 4 bytes.
        CopyMemory timerTemp, lngPtr, 4
        ' Now set the return object from the temporal object.
        Set GetCTimer = timerTemp
        ' Now clear the temporal object
        ' WARNING: Failure to do this will make your program crash.
        ' Why? VB will try to reduce the objects reference count to a negative number
        ' because the use of CopyMemory did not increment the COM reference count.
        ' 0& in the CopyMemory call forces this zero to be a long value (4 bytes).
        '   If yo do not do it, you may get a GPF because VB may only allocate 2 bytes (Integer value) for this zero.
        CopyMemory timerTemp, 0&, 4
    End If

End Function


'GREGBTIMERCHANGE
Function GetCTimers(key As String) As CTimers
' This function returns an actual reference to the CTimers object "soft referenced" in the CTimersCol collection.
' It uses the CopyMemory API function to create the actual reference from the pointer value.
' The CTimers class uses "soft referencing" in order to avoid a circular reference with the CTimersCol collection.
' The CTimersCol collection stores pointers to the CTimers object memory locations instead of direct references to the objects.
' If we do not use soft referencing then when the calling code does this
'      Set timersMyTimers = Nothing
'   the timersMyTimers instance would still stay in memory because the CTimersCol collection (in MTimer)
'   is still holding a reference to it and the timersMyTimers.Class_Terminate event never fires.
    
    ' Temporal object.
    Dim timersTemp As CTimers
    ' Private variable to hold the pointer to the CTimers object.
    Dim lngPtr As Long
    
On Error Resume Next
    ' Get the pointer that is stored in the CTimersCol collection.
    lngPtr = CTimersCol(key)
    If Err <> 0 Then
        ' The collection doesn't exist.
        Set GetCTimers = Nothing
    Else
On Error GoTo 0
        ' Copy the pointer stored in lngPtr to the temporal object variable.
        ' A Long is 4 bytes.
        CopyMemory timersTemp, lngPtr, 4
        ' Now set the return object from the temporal object.
        Set GetCTimers = timersTemp
        ' Now clear the temporal object
        ' WARNING: Failure to do this will make your program crash.
        ' Why? VB will try to reduce the objects reference count to a negative number
        ' because the use of CopyMemory did not increment the COM reference count.
        ' 0& in the CopyMemory call forces this zero to be a long value (4 bytes).
        '   If yo do not do it, you may get a GPF because VB may only allocate 2 bytes (Integer value) for this zero.
        CopyMemory timersTemp, 0&, 4
    End If

End Function

